SystemOrganization addCategory: #'Rome-Base'!

Object subclass: #RomeCanvas
	instanceVariableNames: ''
	classVariableNames: 'ForceBalloonCanvas'
	poolDictionaries: ''
	category: 'Rome-Base'!

!RomeCanvas class methodsFor: 'subclasses' stamp: 'bf 7/24/2006 14:10'!
asConcreteCanvas
	^self isAbstract
		ifTrue: [self concreteCanvas]
		ifFalse: [self]
! !

!RomeCanvas class methodsFor: 'subclasses' stamp: 'bf 8/28/2006 18:56'!
concreteCanvas
	ForceBalloonCanvas == true ifFalse: [
		Smalltalk at: #RomePluginCanvas ifPresent: [:pluginCanvas | 
			pluginCanvas pluginAvailable ifTrue: [^pluginCanvas]]].
	Smalltalk at: #RomeBalloonCanvas ifPresent: [:balloonCanvas |
		^balloonCanvas].
	self error: 'no concrete rome canvas available'! !

!RomeCanvas class methodsFor: 'subclasses' stamp: 'bf 7/24/2006 11:04'!
isAbstract
	^self == RomeCanvas! !

!RomeCanvas class methodsFor: 'instance creation' stamp: 'bf 7/24/2006 14:09'!
new
	^self asConcreteCanvas on: Display! !

!RomeCanvas class methodsFor: 'instance creation' stamp: 'bf 7/24/2006 14:12'!
on: aForm
	^self isAbstract	
		ifTrue: [self concreteCanvas on: aForm]
		ifFalse: [super new setTarget: aForm]! !

!RomeCanvas methodsFor: 'converting' stamp: 'bf 7/25/2006 11:12'!
asRomeCanvas
	^self! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:44'!
blendImage: aForm
	"Draw a translucent image with the set of parameters"
	^self blendImage: aForm at: 0@0! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:44'!
blendImage: aForm at: aPoint
	"Draw a translucent image with the set of parameters"
	^self blendImage: aForm at: aPoint sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:09'!
blendImage: aForm at: aPoint sourceRect: aRectangle
	"Draw a translucent image with the set of parameters"
	^self blendImage: aForm in: (aPoint extent: aRectangle extent) sourceRect: aRectangle! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:46'!
blendImage: aForm in: destRect
	"Draw a translucent image with the set of parameters"
	^self blendImage: aForm in: destRect sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 14:01'!
blendImage: aForm in: destRect sourceRect: aRectangle
	"Draw a translucent image with the set of parameters"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing' stamp: 'bf 7/29/2006 01:39'!
clear
	"clear current clip region to selected fill"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 8/1/2006 00:50'!
clipRectangle: aRect
	"clip all further drawing to aRectangle"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 14:31'!
drawArc: radius at: aPoint from: angle1 to: angle2
	"Draw an arc segment. The arc will be drawn in CW direction. 
	To reverse the direction of the arc use a negative radius"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 14:31'!
drawCurveFrom: start via: cp1 and: cp2 to: end
	"Draw a cubic bezier curve"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 14:31'!
drawCurveFrom: start via: offCurve to: end
	"Draw a quadratic bezier curve"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:46'!
drawImage: aForm
	"Draw a fully opaque image with the set of parameters"
	^self drawImage: aForm at: 0@0! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:44'!
drawImage: aForm at: aPoint
	"Draw a fully opaque image with the set of parameters"
	^self drawImage: aForm at: aPoint sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:09'!
drawImage: aForm at: aPoint sourceRect: aRectangle
	"Draw a fully opaque image with the set of parameters"
	^self drawImage: aForm in: (aPoint extent: aRectangle extent) sourceRect: aRectangle! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:51'!
drawImage: aForm in: destRect
	"Draw a fully opaque image with the set of parameters"
	^self drawImage: aForm in: destRect sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 14:01'!
drawImage: aForm in: destRect sourceRect: sourceRect
	"Draw a fully opaque image with the set of parameters"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 14:32'!
drawLineFrom: startPoint to: endPoint
	"Draw a line from startPoint to endPoint."
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/25/2006 14:26'!
drawOval: aRectangle
	"Draw an oval specified by the given rectangle"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/25/2006 17:51'!
drawPolygon: aCollection
	"Draw a polygon using the given set of vertices"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 17:51'!
drawPolyline: aCollection
	"Draw a polyline using the given set of vertices"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/25/2006 14:26'!
drawRectangle: aRectangle
	"Draw aRectangle."
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/25/2006 14:25'!
drawRoundRect: aRectangle radius: radius
	"Draw a rounded rectangle"
	^self drawRoundRect: aRectangle radius: radius corners: 15! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/31/2006 14:19'!
drawRoundRect: aRectangle radius: aRadius corners: flags
	"Draw a round rectangle using the specified position and size, radius, and corners to round (sum of 1=topLeft, 2=bottomLeft, 4=bottomRight, 8=topRight)."
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'bf 7/25/2006 14:22'!
drawString: aString
	"Draw a string with the given set of parameters"
	^self drawString: aString at: 0@0! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'bf 7/25/2006 14:22'!
drawString: aString at: aPoint
	"Draw a string with the given set of parameters"
	^self drawString: aString at: aPoint from: 1 to: aString size! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'bf 7/25/2006 14:23'!
drawString: aString at: aPoint from: startIndex to: stopIndex
	"Draw a string with the given set of parameters"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'initialize-release' stamp: 'bf 8/23/2006 10:57'!
finish
	"Flushes the canvas and ensures that he effects are visible on the underlying output medium."! !

!RomeCanvas methodsFor: 'initialize-release' stamp: 'bf 8/23/2006 10:58'!
finish: aRectangle
	"Flushes the canvas and ensures that the effects in aRectangle are visible on the underlying output medium."
	^self finish! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:48'!
font
	"Answer the currently selected font"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:49'!
fontMatrix
	"Answer the current transform for fonts"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:47'!
fontMatrix: aTransform
	"Set the matrix transforming from font design units to user space.
	Normally this is just a scale (via fontSize) but can be overridden
	to achieve shearing and other effects."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:49'!
fontSize
	"Answer the currently selected font size."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:48'!
fontSize: aNumber
	"Select a new font size."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:47'!
font: aFont
	"Set the font to be used for subsequent drawing"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'bf 7/25/2006 14:24'!
measureString: aString
	"Measure the extent of aString."
	^self measureString: aString from: 1 to: aString size! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'bf 7/25/2006 14:24'!
measureString: aString from: startIndex to: stopIndex
	"Measure the extent of aString."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:51'!
paintImage: aForm
	"Draw a color keyed image with the set of parameters"
	^self paintImage: aForm at: 0@0! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:51'!
paintImage: aForm at: aPoint
	"Draw a color keyed image with the set of parameters"
	^self paintImage: aForm at: aPoint sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:08'!
paintImage: aForm at: aPoint sourceRect: aRectangle
	"Draw a color keyed image with the set of parameters"
	^self paintImage: aForm in: (aPoint extent: aRectangle extent) sourceRect: aRectangle! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:52'!
paintImage: aForm in: destRect
	"Draw a color keyed image with the set of parameters"
	^self paintImage: aForm in: destRect sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 14:02'!
paintImage: aForm in: destRect sourceRect: aRectangle
	"Draw a color keyed image with the set of parameters"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'preserve state' stamp: 'bf 8/1/2006 00:45'!
preserveStateDuring: aBlock
	"Restore all attributes after evaluating aBlock"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'preserve state' stamp: 'bf 8/1/2006 00:45'!
preserveTransformDuring: aBlock
	"Restore transform after evaluating aBlock"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:34'!
rotateBy: angle
	"Rotate all further drawing operations by angle"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:34'!
rotateBy: angle around: center
	"Rotate all further drawing operations by angle around center"
	^self
		translateBy: center;
		rotateBy: angle;
		translateBy: center negated! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:34'!
scaleBy: scale
	"Scale all further drawing operations by scale"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 8/1/2006 00:43'!
selectFill: aFill
	"Select the fill to use to use for subsequent drawing.
	This is a write-only operation."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 8/1/2006 00:44'!
selectNoFill
	"Do not fill shapes"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 7/31/2006 17:15'!
selectNoPen
	"Do not draw outlines of shapes"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 7/31/2006 16:42'!
selectPenWidth: aNumber color: aColor
	"select a solid Pen of width and color"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm
	"Paint selected fill wherever aForm is non-transparent"
	^self stencilImage: aForm at: 0@0! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm at: aPoint
	"Paint selected fill wherever aForm is non-transparent"
	^self stencilImage: aForm at: aPoint sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm at: aPoint sourceRect: aRectangle
	"Paint selected fill wherever aForm is non-transparent"
	^self stencilImage: aForm in: (aPoint extent: aRectangle extent) sourceRect: aRectangle! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm in: destRect
	"Paint selected fill wherever aForm is non-transparent"
	^self stencilImage: aForm in: destRect sourceRect: aForm boundingBox
! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm in: destRect sourceRect: aRectangle
	"Paint selected fill wherever aForm is non-transparent"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:35'!
transform
	"Answer the currently selected transform"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:35'!
transformBy: aTransform
	"Transform all further drawing operations by aTransform"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:35'!
transform: aTransform
	"Set the transform to be used for subsequent drawing"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:35'!
translateBy: offset
	"Offset all further drawing operations by offset"
	^self subclassResponsibility
! !

Object subclass: #RomeFont
	instanceVariableNames: 'familyName styleName bold italic postscriptName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rome-Base'!

!RomeFont methodsFor: 'converting' stamp: 'bf 7/31/2006 14:58'!
asRomeFont
	^self! !

!RomeFont methodsFor: 'accessing' stamp: 'jl 7/5/2006 16:52'!
familyName
	^familyName! !

!RomeFont methodsFor: 'testing' stamp: 'bf 8/23/2006 14:40'!
hasLatinGlyphs
	"Answer false if font does not provide latin glyphs"
	^true! !

!RomeFont methodsFor: 'testing' stamp: 'jl 7/5/2006 16:51'!
isBold
	^bold! !

!RomeFont methodsFor: 'testing' stamp: 'jl 7/5/2006 16:51'!
isItalic
	^italic ! !

!RomeFont methodsFor: 'accessing' stamp: 'mir 7/9/2006 15:01'!
postscriptName
	^postscriptName ifNil: [postscriptName := (self familyName,'-',self styleName) copyWithout: $ .]! !

!RomeFont methodsFor: 'accessing' stamp: 'jl 7/5/2006 16:52'!
styleName
	^styleName! !
